import java.util.Hashtable;
import java.util.Iterator;
import java.util.Locale;
import java.util.Set;
import java.util.Vector;

import javax.management.ObjectName;

import com.ibm.websphere.management.AdminClient;
import com.ibm.websphere.management.application.AppConstants;
import com.ibm.websphere.management.application.AppManagement;
import com.ibm.websphere.management.application.AppManagementProxy;
import com.ibm.websphere.management.application.client.AppDeploymentTask;


public class Example3 {

    AdminClient adminClient;
    ObjectName mBean;
    
    public void targetApp(String appName, String cellName, String nodeName, String serverName) {

        try {

            // create AppManagement proxy to AppManagement MBean using AdminClient
            adminClient = ExampleUtils.getAdminClient();
            AppManagement appMgmt =
                AppManagementProxy.getJMXProxyForClient(adminClient);

            // prepare properties table
            Hashtable prefs = new Hashtable();
            prefs.put(AppConstants.APPDEPL_LOCALE, Locale.getDefault());

//            Vector v = appMgmt.listApplications(props, null);
//            Iterator i = v.iterator();
//            System.out.println("Installed applications:");
//            while (i.hasNext()) {
//                System.out.println("   " + i.next());
//            }
           
            // We could do this...
            Vector allTasks = appMgmt.getApplicationInfo(appName, prefs, null);
            // ... but we would be requesting much more information than we
            // need for this example and we would have to iterate through
            // allTasks to find the module to server mappings.  Instead, we can
            // get just the data we need via listModules
            //AppDeploymentTask task = (AppDeploymentTask)appMgmt.listModules(appName, prefs, null);
            Iterator iterator = allTasks.iterator();
            while (iterator.hasNext()) {
                AppDeploymentTask task = (AppDeploymentTask)iterator.next();
                if (task.getName().equals("MapModulesToServers")) {
                    // See pages 257 through 262 for an explanation of working with
                    // task data.  In this case ...
                    String target =
                        "WebSphere:cell=" + cellName
                            + ",node=" + nodeName
                            + ",server=" + serverName;
                    String[][] data = task.getTaskData();
                    data[0][0] = "MapModulesToServers";
                    for (int i = 1; i < data.length; i++) {
                        data[i][2] = target;
                        System.out.println("module name: " + data[i][0]);
                        System.out.println("module URI:  " + data[i][1]);
                        System.out.println("target:      " + data[i][2]);
                    }

                    // Save the updated application data
                    task.setTaskData(data);
                }
            }
            
            appMgmt.setApplicationInfo(appName, prefs, null, allTasks);
            System.out.println("The application was updated successfully.");
            
            
            // create module to server relations table
//            Hashtable module2server = new Hashtable();
//            String target = "WebSphere:cell=" + cellName + ",node=" + nodeName + ",server=" + serverName;
//                //"WebSphere:cell=cellName,cluster=clusterName");  // cluster target would be specified like this
//            module2server.put("ivtEJB.jar+META-INF/ejb-jar.xml", target);
//            module2server.put("ivt_app.war+WEB-INF/web.xml", target);
//                
//            props.put(AppConstants.APPDEPL_MODULE_TO_SERVER, module2server);

            // call install
//            System.out.println("Calling installApplication");
//            appMgmt.installApplication(earFile, props, null);
//            System.out.println("Back from installApplication");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
    }

    private ObjectName getAppManagementMBean(AdminClient adminClient) {
        ObjectName appMgmt = null;

        // Query for the ObjectName of the NodeAgent MBean on the given node
        try {
            String query = "WebSphere:type=AppManagement,*";
            ObjectName queryName = new ObjectName(query);
            Set s = adminClient.queryNames(queryName, null);
            
            // There should be exactly one AppManagement MBean
            if (!s.isEmpty())
                appMgmt = (ObjectName) s.iterator().next();
            else
                System.out.println("AppManagement MBean was not found");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }

        return appMgmt;
    }


    public static void main(String[] args) {
        if (args.length == 4) {
        Example3 ex3 = new Example3();
        ex3.targetApp(args[0], args[1], args[2], args[3]);
    }
    else
        System.out.println("Usage: Example3 appName cellName nodeName serverName");
}
}
